<?php

class Controller_Api_V0_Student extends Controller_Handler_Api
{
    public function action_get_index() {
        $this->response->body( '{ what: get index }' );

        return '{ what: get index }'; //$this->response;
    }

    /**
     * @api {put} api/v0/student Add new student(s)
     * @apiName Add new student
     * @apiGroup Student
     * @apiVersion 0.1.0
     * @apiParam {String} token Api key
     * @apiParam {String} [batch] Flag about massive addition
     * @apiParam {String} firstName
     * @apiParam {String} secondName
     * @apiParam {String} lastName
     * @apiParam {String} departmentName
     * @apiParam {String} [departmentID]
     * @apiParam {String} jobPositionName
     * @apiParam {String} [jobPositionID]
     * @apiParam {String} status
     */
    public function action_put_recordBook() {
        try {
            if ( $this->request->query('batch') !== NULL ) {
                $data = json_decode($this->request->body());

                $res = [];
                foreach ($data as $item) {
                    $data = $this->normalizeTeacherData($item);
                    $res[] = $this->createTeacher($data);
                }
            } else {
                $data = [ 'firstName' => $this->request->query('firstName')
                    , 'secondName' => $this->request->query('secondName')
                    , 'lastName' => $this->request->query('lastName')
                    , 'departmentName' => $this->request->query('departmentName')
                    , 'departmentID' => $this->request->query('departmentID')
                    , 'jobPositionName' => $this->request->query('jobPositionName')
                    , 'jobPositionID' => $this->request->query('jobPositionID')
                    , 'status' => $this->request->query('status')];

                $data = $this->normalizeTeacherData((object)$data);
                $res[] = $this->createTeacher($data);
            }
        } catch (Exception $e) {
            $this->badRequestError($e->getMessage());
        }

        return $res;
    }

    /**
     * @api {put} api/v0/student Add new student(s)
     * @apiName Add new student
     * @apiGroup Student
     * @apiVersion 0.1.0
     * @apiParam {String} token Api key
     * @apiParam {String} [batch] Flag about massive addition
     * @apiParam {String} firstName
     * @apiParam {String} secondName
     * @apiParam {String} lastName
     * @apiParam {String} departmentName
     * @apiParam {String} [departmentID]
     * @apiParam {String} jobPositionName
     * @apiParam {String} [jobPositionID]
     * @apiParam {String} status
     */
    public function action_put_index() {
        try {
            if ( $this->request->query('batch') !== NULL ) {
                $data = json_decode($this->request->body());

                $res = [];
                foreach ($data as $item) {
                    $data = $this->normalizeTeacherData($item);
                    $res[] = $this->createTeacher($data);
                }
            } else {
                $data = [ 'firstName' => $this->request->query('firstName')
                    , 'secondName' => $this->request->query('secondName')
                    , 'lastName' => $this->request->query('lastName')
                    , 'departmentName' => $this->request->query('departmentName')
                    , 'departmentID' => $this->request->query('departmentID')
                    , 'jobPositionName' => $this->request->query('jobPositionName')
                    , 'jobPositionID' => $this->request->query('jobPositionID')
                    , 'status' => $this->request->query('status')];

                $data = $this->normalizeTeacherData((object)$data);
                $res[] = $this->createTeacher($data);
            }
        } catch (Exception $e) {
            $this->badRequestError($e->getMessage());
        }

        return $res;
    }

    public function action_get_list_by_name() {
        return '{ what: nothing }';
    }
}
